(defmacro while (test &rest body)
  `(do () ((not ,test))
     ,@body))

(defun my-mapcar (func lst)
  (let (elt n)
    (while (setq elt (pop lst))
      (push (funcall func elt) n)) ;; <- name clash on n!!
    (nreverse n)))

(defun list+ (lst n)
  (my-mapcar (lambda (x)
	       (declare (special n)) ;; Do that and...
	       (+ x n)) ;; ... barf, name clash on n!!
	     lst))
